varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
precision highp float;
uniform lowp float value;

void main() {
     // functions parameters
     highp vec4 textureRect = vec4(0.5, 0.5, 1.0, 1.0);

     lowp vec4 color = texture2D(inputImageTexture, textureCoordinate);
     lowp vec2 position = textureCoordinate;
     highp vec2 vector = position - vec2(textureRect.x, textureRect.y);
     float distance = length(vector);
     highp vec2 baseDisplacement = -0.01 * vector * value;
     float coefficient = 0.04 * distance * value * min(textureRect.z, textureRect.w);
     highp vec2 offset = coefficient * vector;

     highp vec3  base = texture2D(inputImageTexture, position).xyz;
     float red = texture2D(inputImageTexture, clamp((position + offset + baseDisplacement), 0.0, 1.0)).x;
     float green = texture2D(inputImageTexture, clamp((position + baseDisplacement), 0.0, 1.0)).y;
     float blue = texture2D(inputImageTexture, clamp((position - offset + baseDisplacement), 0.0, 1.0)).z;

     gl_FragColor = vec4(mix(base, vec3(red, green, blue), clamp((4.0 * value), 0.0, 1.0)),color.a);
}
